#define MOTOR_R 9
#define MOTOR_L 11
#define SENSOR_L A0
#define SENSOR_R A1

int speed = 220;
int gray1 = 275;
int gray2 = 320;
float kd = 3;
float kp = 0.6;
int last_err = 0;
int s = 0;
int cnt = 0;


void setup() {
  pinMode(MOTOR_R, OUTPUT);
  pinMode(MOTOR_L, OUTPUT);
  pinMode(SENSOR_L, INPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  digitalWrite(4, LOW);
  digitalWrite(5, HIGH);
  digitalWrite(2, LOW);
  digitalWrite(3, HIGH);
  Serial.begin(9600);
}


void drive_line(int sensor_pin, int inv) {
  int gray;
  if (sensor_pin == A0) gray = gray1;
  else gray = gray2;
  int err = (analogRead(sensor_pin) - gray) * inv;
  int d = err - last_err;
  last_err = err;
  float motorspeed = err * kp + d * kd;
  analogWrite(MOTOR_R, min(max(speed - motorspeed, 0), 255));
  analogWrite(MOTOR_L, min(max(speed + motorspeed, 0), 255));
  Serial.print(speed - motorspeed);
  Serial.print(" ");
  Serial.println(speed + motorspeed);
}

void stop() {
  analogWrite(MOTOR_R, 0);
  analogWrite(MOTOR_L, 0);
}

void drive_line_time(int sensor_pin, int inv, int time) {
  unsigned long start = millis();
  while (millis() - start < time) {
    drive_line(sensor_pin, inv);
  }
  analogWrite(MOTOR_L, 0);
  analogWrite(MOTOR_R, 0);
}

void loop() {
  while (true) {
    if ((analogRead(A1) > gray2 * 0.7 && s == 0) || (analogRead(A0) > gray1 * 0.7 && s == 1)) {
      break;
    }
    if (s == 0)
      drive_line(A0, 1);
    else
      drive_line(A1, -1);
  }

  cnt++;

  if (cnt == 14) {
    stop();
    delay(10000);
  } else {
    s = (s + 1) % 2;
    if (s == 1)
      drive_line_time(A0, 1, 50);
    else
      drive_line_time(A1, -1, 50);

    if (s == 0)
      drive_line_time(A0, 1, 3000);
    else
      drive_line_time(A1, -1, 3000);
  }
}